
Redmine - Defect #16795

Member#destroy triggers after_destroy callbacks twice

2014-05-03 01:48 - Islam Azab

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Jean-Philippe Lang % Done: 0%

Category: Code cleanup/refactoring Estimated time: 0.00 hour

Target version: 2.5.2   

Resolution: Fixed Affected version:  

Description

The callback 'after_destroy' for Member is called twice when deleting a member due to the following lines

https://github.com/redmine/redmine/blob/master/app/controllers/members_controller.rb:99

and

https://github.com/redmine/redmine/blob/master/app/models/member_role.rb:42

Associated revisions

Revision 13140 - 2014-05-24 11:55 - Jean-Philippe Lang

Fixed that Member#destroy triggers after_destroy callbacks twice (#16795).

Revision 13142 - 2014-05-24 12:15 - Toshi MARUYAMA

replace tabs to spaces (#16795)

Revision 13162 - 2014-05-24 18:37 - Jean-Philippe Lang

Merged r13140 and r13142 (#16795).

History

#1 - 2014-05-03 01:51 - Islam Azab

https://github.com/redmine/redmine/blob/master/app/controllers/members_controller.rb

def destroy

    if request.delete? && @member.deletable?

      @member.destroy

    end

    respond_to do |format|

      format.html { redirect_to_settings_in_projects }

      format.js

      format.api {

        if @member.destroyed?

          render_api_ok

        else

          head :unprocessable_entity

        end

      }

    end

  end

 https://github.com/redmine/redmine/blob/master/app/models/member_role.rb

  def remove_member_if_empty

    if member.roles.empty?

      member.destroy

    end

  end

#2 - 2014-05-24 11:56 - Jean-Philippe Lang

- Subject changed from fixed member deletion to avoid dublicate after_destroy callbacks to Member#destroy triggers after_destroy callbacks twice

- Category set to Code cleanup/refactoring
- Status changed from New to Resolved

- Assignee set to Jean-Philippe Lang

- Target version set to 2.5.2

- Resolution set to Fixed

Fixed in r13140, thanks for pointing this out.

#3 - 2014-05-24 18:37 - Jean-Philippe Lang

- Status changed from Resolved to Closed

Merged.

Files

fixed member deletion to avoid dublicate after_destroy callbacks.diff 459 Bytes 2014-05-02 Islam Azab
